
#typedef HWND int
#typedef WPARAM int
#typedef LPARAM int
#typedef LRESULT int
#typedef HGDIOBJ int
#typedef COLORREF int
#typedef HFONT int
#typedef HDC int
#typedef LPSTR pointer
#typedef LPCSTR pointer
#typedef HBRUSH int
#typedef LONG int
#typedef HPEN int
#typedef HBITMAP int
#typedef HMENU int
#typedef HINSTANCE int
#typedef HCURSOR int
#typedef LPVOID pointer
#typedef HANDLE int

struct TEXTMETRIC
{
    LONG        tmHeight;
    LONG        tmAscent;
    LONG        tmDescent;
    LONG        tmInternalLeading;
    LONG        tmExternalLeading;
    LONG        tmAveCharWidth;
    LONG        tmMaxCharWidth;
    LONG        tmWeight;
    LONG        tmOverhang;
    LONG        tmDigitizedAspectX;
    LONG        tmDigitizedAspectY;
    BYTE        tmFirstChar;
    BYTE        tmLastChar;
    BYTE        tmDefaultChar;
    BYTE        tmBreakChar;
    BYTE        tmItalic;
    BYTE        tmUnderlined;
    BYTE        tmStruckOut;
    BYTE        tmPitchAndFamily;
    BYTE        tmCharSet;
}

struct SIZE {int cx;int cy;}
struct WINDOWPLACEMENT {
    UINT  length;
    UINT  flags;
    UINT  showCmd;
    POINT ptMinPosition;
    POINT ptMaxPosition;
    RECT  rcNormalPosition;
}


declare import, GetTextMetrics alias GetTextMetricsA(HDC hdc,  TEXTMETRIC * lptm),BOOL;
declare import,SetCursor(opt HCURSOR hCursor),HCURSOR;
declare import,DrawFrameControl(HDC hdc,RECT *rc,UINT uType,UINT uState),BOOL;
declare import, SendMessage alias SendMessageA(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam),LRESULT;
declare import, GetClientRect(HWND hWnd, RECT *lpRect),BOOL;
declare import, GetStockObject(int i),HGDIOBJ; 
declare extern  lstrcpy alias _astrcpy(LPSTR lpString1,LPCSTR lpString2),LPSTR;
declare extern  lstrcat alias _astrcat(LPSTR lpString1,LPCSTR lpString2),LPSTR;
declare import,lstrcpyn alias lstrcpynA(LPSTR lpString1,LPCSTR lpString2,int iMaxLength),LPSTR;
declare extern lstrlen alias _astrlen(LPCSTR lpString),int;
declare import,GetParent(HWND hWnd),HWND;
declare import,SystemParametersInfo alias SystemParametersInfoA(UINT uiAction,UINT uiParam,PVOID *pvParam,UINT fWinIni),BOOL;
declare import, CreateFont alias CreateFontA(int cHeight, int cWidth, int cEscapement, int cOrientation, int cWeight, DWORD bItalic,
                              DWORD bUnderline, DWORD bStrikeOut, DWORD iCharSet, DWORD iOutPrecision, DWORD iClipPrecision,
                              DWORD iQuality, DWORD iPitchAndFamily, LPCSTR pszFaceName),HFONT;
declare import,PostMessage alias PostMessageA(opt HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam),BOOL;

extern int cdecl isdigit(byte i);
extern int cdecl iswspace(word w);
extern pointer cdecl strtok(char *q, char *w);
extern int wsprintf alias wsprintfA(LPSTR q,...);
declare import, lstrcmp alias lstrcmpA(LPCSTR lpString1,LPCSTR lpString2),int;
declare import,CopyRect(RECT *lprcDst,RECT *lprcSrc),BOOL;
declare import, CreateSolidBrush(COLORREF color),HBRUSH;
declare import, InvalidateRect(HWND hWnd, RECT *lpRect,BOOL bErase),BOOL;
declare import, CharUpper alias CharUpperA(LPSTR lpsz),LPSTR;
declare import,GetDC(opt HWND hWnd),HDC;
declare import,SetWindowLong alias SetWindowLongA(HWND hWnd,int nIndex,LONG dwNewLong),LONG;
declare import,ReleaseDC(HWND hWnd,HDC hDC),int;
declare import,SetScrollPos(HWND hWnd,int nBar,int nPos,BOOL bRedraw),int;
declare import,GetScrollRange(HWND hWnd,int nBar,INT *lpMinPos,INT *lpMaxPos),BOOL;
declare import,ShowScrollBar(HWND hWnd,int wBar,BOOL bShow),BOOL;
declare import, SetBkMode(HDC hdc, int mode),int;
declare import, SelectObject(HDC hdc, HGDIOBJ h),HGDIOBJ;
declare import,DrawEdge(HDC hdc,RECT *qrc,UINT edge,UINT grfFlags),BOOL;
declare import,DrawTextEx alias DrawTextExA(HDC hdc, LPSTR lpchText,int cchText,RECT *lprc,UINT format,optDRAWTEXTPARAMS *lpdtp),int;
declare import, SetTextColor(HDC hdc, COLORREF color),COLORREF;
declare import, Rectangle(HDC hdc, int left, int top, int right, int bottom),BOOL;
declare import, CreatePen(int iStyle, int cWidth, COLORREF color),HPEN;
declare import,GetWindowLong alias GetWindowLongA(HWND hWnd,int nIndex),LONG; 
declare import, DeleteObject(HGDIOBJ ho),BOOL;
declare import, GetROP2(HDC hdc),int;
declare import, SetROP2(HDC hdc, int rop2),int;
declare import,_ToAscii alias ToAscii(UINT uVirtKey,UINT uScanCode, unsigned byte *lpKeyState, WORD *lpChar,UINT uFlags),int;
declare import,GetKeyboardState(unsigned byte *lpKeyState),BOOL;
declare import,CreateWindowEx alias CreateWindowExA(
   DWORD dwExStyle,
   opt LPCSTR lpClassName,
   opt LPCSTR lpWindowName,
   DWORD dwStyle,
   int X,int Y,int nWidth,int nHeight,
   opt HWND hWndParent,
   opt HMENU hMenu,
   opt HINSTANCE hInstance,
   opt LPVOID lpParam),HWND;
extern _hinstance as HINSTANCE;
declare import,GetTextExtentPoint32 alias GetTextExtentPoint32A(HDC hdc,LPCSTR lpString,int c,SIZE * psizl),BOOL;
declare import,SetScrollRange(HWND hWnd,int nBar,int nMinPos,int nMaxPos,BOOL bRedraw),BOOL;
declare import,CreateCaret(HWND hWnd,opt HBITMAP hBitmap,int nWidth,int nHeight),BOOL;
declare import,GetCaretBlinkTime(),UINT;
declare import,SetCaretBlinkTime(UINT uMSeconds),BOOL;
declare import,DestroyCaret(),BOOL;
declare import,HideCaret(HWND hWnd),BOOL;
declare import,ShowCaret(opt HWND hWnd),BOOL;
declare import,SetCaretPos(int X,int Y),BOOL;
declare import,MessageBeep(UINT uType),BOOL;
declare import,DrawText alias DrawTextA(HDC hdc,  LPCSTR lpchText,int cchText,RECT *lprc,UINT format),int;
declare import,GetScrollPos(HWND hWnd,int nBar),int;
declare import,DestroyWindow(HWND hWnd),BOOL;
declare import,LoadCursor alias LoadCursorA(opt HINSTANCE hInstance,LPCSTR lpCursorName),HCURSOR;
declare import,UpdateWindow(HWND hWnd),BOOL;
declare import,GetFocus(),HWND;
declare import,GetSystemMetrics(int nIndex),int;
declare import,GetWindowPlacement(HWND hWnd,WINDOWPLACEMENT *lpwndpl),BOOL;
declare import,SetProp alias SetPropA(HWND hWnd,LPCSTR lpString,opt HANDLE hData),BOOL;
#define LBS_STANDARD          (0x0001 | 0x0002 | AWS_VSCROLL | AWS_BORDER)
#define FF_MODERN           (3<<4)
#define DEFAULT_PITCH           0
#define FIXED_PITCH             1
#define VARIABLE_PITCH          2
#define MONO_FONT               8
#define LB_FINDSTRING           0x018F 
#define SIZE_MAXIMIZED      2
#define WM_SIZE                         0x0005
#define PROOF_QUALITY           2 
#define IDC_SIZEWE          32644
#define VK_DELETE         0x2E
#define VK_NEXT           0x22
#define VK_PRIOR          0x21 
#define VK_LEFT           0x25
#define VK_UP             0x26
#define VK_RIGHT          0x27
#define VK_DOWN           0x28
#define WM_PAINT 0xF
#define VK_TAB            0x09
#define WS_EX_CLIENTEDGE        0x00000200
#define SM_CYHSCROLL            3
#define SB_HORZ             0
#define SB_VERT             1
#define SPI_GETWHEELSCROLLLINES    0x0068
#define R2_XORPEN           7
#define IDC_ARROW           32512
#define LB_ERR              (-1)
#define LB_GETCOUNT             0x018B
#define LB_GETTEXT              0x0189
#define LB_DELETESTRING         0x0182
#define LB_ADDSTRING            0x0180
#define DLGC_DEFPUSHBUTTON  0x0010
#define DLGC_WANTCHARS      0x0080
#define DLGC_WANTARROWS     0x0001

#define DT_TOP                      0x00000000
#define DT_LEFT                     0x00000000
#define DT_CENTER                   0x00000001
#define DT_RIGHT                    0x00000002
#define DT_VCENTER                  0x00000004
#define DT_BOTTOM                   0x00000008
#define DT_WORDBREAK                0x00000010
#define DT_SINGLELINE               0x00000020
#define DT_EXPANDTABS               0x00000040
#define DT_TABSTOP                  0x00000080
#define DT_NOCLIP                   0x00000100
#define DT_EXTERNALLEADING          0x00000200
#define DT_CALCRECT                 0x00000400
#define DT_NOPREFIX                 0x00000800
#define DT_INTERNAL                 0x00001000

#define DT_EDITCONTROL              0x00002000
#define DT_PATH_ELLIPSIS            0x00004000
#define DT_END_ELLIPSIS             0x00008000
#define DT_MODIFYSTRING             0x00010000
#define DT_RTLREADING               0x00020000
#define DT_WORD_ELLIPSIS            0x00040000
#define DT_NOFULLWIDTHCHARBREAK     0x00080000
#define DT_HIDEPREFIX               0x00100000
#define DT_PREFIXONLY               0x00200000

#define VK_F1             0x70
#define VK_F12            0x7B
#define VK_ESCAPE         0x1B


#define DFC_BUTTON              4
#define DFCS_BUTTONCHECK        0x0000
#define DFCS_CHECKED            0x0400
#define GWL_ID              (-12)
#define PS_SOLID            0
#define CW_USEDEFAULT       0x80000000

#define WM_USER 0x400
#define WM_SETFONT                      0x0030
#define WM_COMMAND                      0x0111 
#define WM_MOUSEWHEEL                   0x020A
#define WM_SETTEXT                      0x000C
#define WM_ENABLE                       0x000A
#define WM_ERASEBKGND                   0x0014
#define WM_GETDLGCODE                   0x0087
#define WM_SETFOCUS                     0x0007
#define WM_KILLFOCUS                    0x0008
#define LB_RESETCONTENT         0x0184





#define WHITE_BRUSH         0
#define LTGRAY_BRUSH        1
#define GRAY_BRUSH          2
#define DKGRAY_BRUSH        3
#define BLACK_BRUSH         4
#define NULL_BRUSH          5
#define HOLLOW_BRUSH        NULL_BRUSH
#define WHITE_PEN           6
#define BLACK_PEN           7
#define NULL_PEN            8
#define OEM_FIXED_FONT      10
#define ANSI_FIXED_FONT     11
#define ANSI_VAR_FONT       12
#define SYSTEM_FONT         13
#define DEVICE_DEFAULT_FONT 14
#define DEFAULT_PALETTE     15
#define SYSTEM_FIXED_FONT   16

#define DEFAULT_GUI_FONT    17

#define DC_BRUSH            18
#define DC_PEN              19

#define STOCK_LAST          19

#define CLR_INVALID     0xFFFFFFFF 

#define BDR_RAISEDOUTER 0x0001
#define BDR_SUNKENOUTER 0x0002
#define BDR_RAISEDINNER 0x0004
#define BDR_SUNKENINNER 0x0008

#define BDR_OUTER       (BDR_RAISEDOUTER | BDR_SUNKENOUTER)
#define BDR_INNER       (BDR_RAISEDINNER | BDR_SUNKENINNER)
#define BDR_RAISED      (BDR_RAISEDOUTER | BDR_RAISEDINNER)
#define BDR_SUNKEN      (BDR_SUNKENOUTER | BDR_SUNKENINNER)


#define EDGE_RAISED     (BDR_RAISEDOUTER | BDR_RAISEDINNER)
#define EDGE_SUNKEN     (BDR_SUNKENOUTER | BDR_SUNKENINNER)
#define EDGE_ETCHED     (BDR_SUNKENOUTER | BDR_RAISEDINNER)
#define EDGE_BUMP       (BDR_RAISEDOUTER | BDR_SUNKENINNER) 

#define BF_MIDDLE       0x0800  /*Fill in the middle */
#define BF_SOFT         0x1000  /*For softer buttons */
#define BF_ADJUST       0x2000  /*Calculate the space left over */
#define BF_FLAT         0x4000  /*For flat rather than 3D borders */
#define BF_MONO         0x8000  /*For monochrome borders */

#define BF_LEFT         0x0001
#define BF_TOP          0x0002
#define BF_RIGHT        0x0004
#define BF_BOTTOM       0x0008

#define BF_TOPLEFT      (BF_TOP | BF_LEFT)
#define BF_TOPRIGHT     (BF_TOP | BF_RIGHT)
#define BF_BOTTOMLEFT   (BF_BOTTOM | BF_LEFT)
#define BF_BOTTOMRIGHT  (BF_BOTTOM | BF_RIGHT)
#define BF_RECT         (BF_LEFT | BF_TOP | BF_RIGHT | BF_BOTTOM)

#define BF_DIAGONAL     0x0010

